//arlotto 2007 : dialogue avec un sonar i2c srf08
// configurer le terminal 9600 N 8 1 pas de contrle de flux transmission de CR en fin de ligne
#include <p18cxxx.h> 
#include <usart.h>   // pour fonctions UART
#include <string.h>  // pour strmcp
#include <stdio.h>  // pour printf
#include <stdlib.h> // pour atoi
#include <i2c.h>    // pour fct i2c
#include <timers.h>
#include "srf08.h"

// configuration quartz
#pragma config OSC = XT
#pragma config WDT = OFF
#pragma config LVP = OFF
#pragma config PBADEN = OFF

// defines pour la carte
#define Button PORTBbits.RB0
#define GreenLed PORTBbits.RB1
#define RedLed   PORTBbits.RB2


// defines liaison srie
#define MAX_MSG 20
#define CAR_CR 0x0D
#define CAR_LF 0x0A
#define CAR_BS 0x08
#define USAGE "Commandes :\r\n\
				\tHelp\r\n\
				\tDistance\r\n\
				\tEchos\r\n\
                \tCont (s ou S pour stop)\r\n"

#define MODE_NORMAL 0
#define MODE_CONTINU 1

//prototype du gestionnaire d'interruption
void InterruptHandlerHigh (void);

volatile char r ; // indique qu'une chane complte  t reue
volatile char mode = MODE_NORMAL ;
volatile char mesure ; 
char msg[MAX_MSG+1]; // stocke la chane reue

void main(void){
int x ;
int i , iesp ;
int d ;
int tab_echos[17];

GreenLed= 0 ;
RedLed = 0 ;
TRISBbits.TRISB1=0;
TRISBbits.TRISB2=0;
// init 9600Bd  4Mhz avec it en rx 
OpenUSART( USART_TX_INT_OFF &
USART_RX_INT_ON &
USART_ASYNCH_MODE &
USART_EIGHT_BIT &
USART_CONT_RX &
USART_BRGH_HIGH,
25 );
// init i2c 
OpenI2C(MASTER,SLEW_OFF);
SSPADD = 9 ;
x=SSPBUF ;
// init timer 1 Thorloge = 8x4xTosc = 8us
OpenTimer1(TIMER_INT_ON   &
           T1_16BIT_RW    &
           T1_SOURCE_INT  &
           T1_PS_1_8      );
WriteTimer1(3036);   // 65536 - 3036 = 62500 : 8us*62500 = 0.5s

INTCONbits.PEIE = 1 ; // autorisation des it priphriques
INTCONbits.GIE = 1 ; // autorisation globale des it
printf("\r\n\r\n**** Mise en oeuvre du sonar ultrason SRF08 ****\r\n\r\n");
printf(USAGE">");
for( ;; )
{
 
 if(r){
   if(strcmppgm2ram(msg,"")==0 ) goto ok ; 
   if(strcmppgm2ram(msg,"Help")==0 ){ printf(USAGE); goto ok ; }
   // Recherche espace
   for(i=0;msg[i]!=' ' && i<=MAX_MSG ; i++ ) ;

     if ( i==MAX_MSG )  goto pas_de_param ;  
     iesp = i ;
     msg[iesp] = '\0' ;  
 param: 

 pas_de_param:
         if(strcmppgm2ram(msg,"Distance")==0 ) { 
             RedLed = 1 ;
             d=read_distance();  
             printf("\r\nDistance = %d cm\r\n",d);
             RedLed = 0 ;
            goto ok ;
       }
        if(strcmppgm2ram(msg,"Echos")==0 ) { 
             RedLed = 1 ;
             read_distance();  
             d=read_all_echos(tab_echos);  
             printf("\r\nEchos : %d\r\n",d);
             for(i=0 ; i < d ; i++ ) {
               printf("%2d : %4d cm\r\n",i,tab_echos[i]);
             }
             RedLed = 0 ;
            goto ok ;
       }
       if(strcmppgm2ram(msg,"Cont")==0 ) { 
             printf("Mode echos en continu (S ou s pour Stop)\r\n");
             mode = MODE_CONTINU ;         
             goto ok ;
       }

      error:    printf((rom char*)"Unknown command :%s !!\r\n\x7",msg);
      ok :      printf("\r\n>");
     r=0;
    }
// mode echos continu 
if ( mesure && mode==MODE_CONTINU ) {
     RedLed = 1 ;
     read_distance();  
     d=read_all_echos(tab_echos);  
     printf("\r\n%2d Echos:",d);
             for(i=0 ; i < d ; i++ ) {
               printf("%4d ",tab_echos[i]);
             }
    printf("\r\n");
    RedLed = 0 ;
    mesure = 0 ;
}

 // clignotement
x++;
if (x>=3000){
GreenLed = !GreenLed ;
x=0; }    
}
}

//Placement d'un saut vers le gestionnaire d'interruption
//----------------------------------------------------------------------------
// High priority interrupt vector
#pragma code InterruptVectorHigh = 0x08
void
InterruptVectorHigh (void)
{
  _asm
    goto InterruptHandlerHigh //jump to interrupt routine
  _endasm
}

// Routine gestionnaire d'interruption
//----------------------------------------------------------------------------
// High priority interrupt routine
#pragma code
#pragma interrupt InterruptHandlerHigh
void
InterruptHandlerHigh ()
{ 
   static char i ; // doit tre statique pour conserver sa valeur entre les IT    
   char c ;
  // Partie rception d'un caractre
  if(PIR1bits.RCIF) // si un car arriv
    {
      c=ReadUSART(); // le lire
      WriteUSART(c); // echo
     switch(mode) {
     case MODE_NORMAL :
      if( c==CAR_BS)
        {
         if(i>0){
             i--;  }
        }
      else {
        if(c!=CAR_CR && i<MAX_MSG)
         {
           msg[i++]=c ; // stockage
         }else
         {
           msg[i]='\0'; // fin de chane si CR
           i=0;
           r=1;
         } 
      }
      break ;
     case MODE_CONTINU :
     if( c=='S' || c=='s') {
       mode = MODE_NORMAL ;
     }
     break ;
     }
    }
    if(PIR1bits.TMR1IF ){
          PIR1bits.TMR1IF = 0 ;
          WriteTimer1(3036);  
          mesure = 1 ;
    }
}
