//arlotto 2007 : Fonctions de bases pour le sonar srf08
#include <p18cxxx.h> 
#include <stdio.h> 
#include <i2c.h>    // pour fct i2c
#include <delays.h>
#include "srf08.h"

// retourne le premier echo en cm
int read_distance(void) {
   unsigned char dl ,  dh ;
   int d ;

   StartI2C();
   IdleI2C();
   WriteI2C(SRF08_ADDRESS);  
   IdleI2C();
   WriteI2C(SRF08_CMD_REG);
   WriteI2C(SRF08_START_RANGING_CM);  
   IdleI2C();
   StopI2C();
   IdleI2C();
   
   Delay10KTCYx(8) ;

   StartI2C();   
   IdleI2C();
   WriteI2C(SRF08_ADDRESS);
   IdleI2C();           
   WriteI2C(SRF08_FISRT_ECHO_REG);
   IdleI2C();
   RestartI2C();   
   IdleI2C();
   WriteI2C(SRF08_ADDRESS|1);
   IdleI2C(); 
   dh = ReadI2C();
   IdleI2C();  
   AckI2C(); 
   IdleI2C();           
   dl = ReadI2C();
   IdleI2C();
   NotAckI2C();
   IdleI2C();
   StopI2C();
   IdleI2C(); 
   d = (dh<<8) + dl ;
     return d ;
}

// Lance une mesure de distance avec rsultat en cm
void StartRangingCm ( void ) {
   StartI2C();
   IdleI2C();
   WriteI2C(SRF08_ADDRESS);  
   IdleI2C();
   WriteI2C(SRF08_CMD_REG);
   WriteI2C(SRF08_START_RANGING_CM);  
   IdleI2C();
   StopI2C();
   IdleI2C();
}
   
// retourne la distance de l'cho N n ( 0 <= n <SRF08_MAX_ECHOS )          
int read_echo (int n ) {
unsigned char dl ,  dh ;
int dn ;
 
   if( n<0 || n>=SRF08_MAX_ECHOS ) 
          return 0 ;
   StartI2C();   
   IdleI2C();
   WriteI2C(SRF08_ADDRESS);
   IdleI2C();           
   WriteI2C(SRF08_FISRT_ECHO_REG + 2*n );
   IdleI2C();
   RestartI2C();   
   IdleI2C();
   WriteI2C(SRF08_ADDRESS|1);
   IdleI2C(); 
   dh = ReadI2C();
   IdleI2C();  
   AckI2C(); 
   IdleI2C();           
   dl = ReadI2C();
   IdleI2C();
   NotAckI2C();
   IdleI2C();
   StopI2C();
   IdleI2C(); 
   dn = (dh<<8) + dl ;
        return dn ;

} 
// Lit tous les echos jusqu' avoir un echo nul
// retourne le nombre d'chos non nul
// rempli le tableau avec les valeurs de chaque echo
int read_all_echos ( int *  tab_echo ) {

    int i , necho ;
  
     for ( i=0 ; i<SRF08_MAX_ECHOS && (tab_echo[i]=read_echo(i))!=0 ; i++ ) ;
     necho = i ;
     for( ; i < SRF08_MAX_ECHOS ; i++ ) 
         { tab_echo[i]=0 ; }
     return necho ;
        
}
